# -*- coding: utf-8 -*-

import redis
import json
import pickle

from django.conf import settings

REDIS_HOST = settings.REDIS_HOST
REDIS_PORT = settings.REDIS_PORT
REDIS_DB = settings.REDIS_DB


class RedisCached(object):
    def __init__(self, key, path):
        super(RedisCached, self).__init__()
        self.r = redis.StrictRedis(REDIS_HOST, REDIS_PORT, REDIS_DB)
        self.key = key
        self.path = path
        if self.r.exists(key):
            self.data = self._get_data()
        else:
            self.data = self._set_data()

    def _set_data(self):
        with open(self.path, 'r') as f:
            if self.r.set(self.key, pickle.dumps(json.loads(f.read()))):
                return pickle.loads(self.r.get(self.key))
            raise redis.exceptions.RedisError

    def _get_data(self):
        return pickle.loads(self.r.get(self.key))
